package interestRate;

import java.io.*;

/**
   Implements a Key used in the interest rate
   lattice.
   */
public class Key implements KeyInterface {

  //time 
  public int t;

  //Number of up-ticks from the 
  //root to that node
  public int up_ticks;


  //short rate at that node
  public double short_rate;

  //option value
  public double option_value;

  //constructor
  public Key(int t, int u) {
    this.t = t;
    up_ticks = u;
  }//end of constructor


  public void print() {
    System.out.print("time: "); System.out.print(t);
    System.out.print(" up_ticks:  "); System.out.print(up_ticks);
    System.out.print(" short_rate:  "); System.out.print(short_rate);
    System.out.print(" option_value: "); System.out.print(option_value);
    System.out.println();
  }//end of print

  public boolean isEqual(KeyInterface key) {
    Key k = (Key)key;
    if (k.t == t && k.up_ticks == up_ticks) return(true);

    return(false);
  }//end of isEqual


}//end of class Key
    
    
      
    


