package interestRate;

import mathUtil.*;

public class SlowYieldVolObject extends AbstractFunctionObject {

  AbstractTermStructure termStructureObj;

  //Yield and volatality are computed for the
  //bond of that maturity
  public int maturity;

  private static final boolean DEBUG=false;

  public SlowYieldVolObject(AbstractTermStructure aTerm) {
    
    //call the constructor for the super class
    super(2);
    termStructureObj = aTerm;
  }//end of constructor


  //If i==0 calculate the yield and otherwise 
  //calculate the vol. Use values as value
  //of r[t] and k[t]
  public double evaluate(int i, double val[]) {
    termStructureObj.r[maturity-1]=val[0];
    termStructureObj.k[maturity-1]=val[1];
    
    if (i==0) {
      double tempYield =termStructureObj.slowYield(0,0,maturity);
      if (DEBUG) {
	System.out.println("SlowYieldVolObject:evaluate: maturity tempYield val");
	System.out.println(maturity);
	System.out.println(tempYield);
	System.out.println(val[0]);
	System.out.println(val[1]);
      }
	
	
      return(tempYield-termStructureObj.yield[maturity-1]);
    }
    else {
      double tempVol = termStructureObj.slowLogVol(0,0,maturity);
      if (DEBUG) {
	System.out.println("SlowYieldVolObject:evaluate: maturity tempYield val");
	System.out.println(maturity);
	System.out.println(tempVol);
	System.out.println(val[0]);
	System.out.println(val[1]);
      }

      return(tempVol-termStructureObj.volatilities[maturity-1]);
    }
  }//end of evaluate

}//end of SlowYieldVolObject
		     
